#include <math.h>
#include <stdlib.h>
#include <string>
#include <vector>

#define LARGENUM 999999

using namespace std;

class energy_parameters	{
	public:
	
	string sequence;	
	vector<int> Loop_internal;
	vector<int> Loop_bulge;
	
	vector<int> Loop_hairpin;
	vector<int> Loop_tri_hairpin;
	vector<int> Loop_tetra_hairpin;
	vector<int> Loop_hexa_hairpin;
	
	vector< vector<int> >Internal_GG;
	
	vector< vector<int> > stacking_pairs;
	vector< vector< vector<int> > > terminal_mismatch;
	int Internal_assymmetric_penalty;
	int Internal_nonCG_closing_penalty;
	int Multi_closing;
	int Multi_new_branch;
	
	energy_parameters(string input_sequence);
	~energy_parameters();
	
	void set_pseudo_stack_energy(void);
	void recover_pseudo_stack_energy(void);
	
	int index_nuc(char a);
	int index_pair(char a, char b);
	
	int FE_loop(int fiveP_out, int threeP_out, int fiveP_in, int threeP_in);
	int FE_hairpin(int fiveP, int threeP);
	int FE_stack(int fiveP, int threeP);
	
};
