#include <iostream>
#include <fstream>
#include <string>
#include <string.h>
#include <vector>
#include <cstdlib>
#include <math.h>

using namespace std;

class shape_reactivity	{
	public:
	
	vector<double> reactivity;
	string sequence;
	double slope, intercept;
		
	shape_reactivity(string input_sequence, vector<double> input_reactivity);
	shape_reactivity(string input_sequence, string shape_file_name);
	~shape_reactivity(void);
	
	int pseudo_energy_pair(int i);
	int pseudo_energy_pair_constrained(int i, char constraint, int frequency);
	int pseudo_energy_unpair(int i);
	int pseudo_energy_unpair_constrained(int i, char constraint, int frequency);
	int pseudo_energy_stack(vector<int> stack);
	int pseudo_energy_stack_constrained(vector<int> stack, string constraint_str, int frequency);
	int evaluate_pseudo_energy(int begin, int end, string structure, string constraint, int frequency);
	int evaluate_pseudo_energy_exclude(int begin, int end, int begin_exclude, int end_exclude, 
		string structure, string constraint, int frequency);
	void adjust_unconstrained_energy(string inferred_str, int &energy);
	int optimistic_pseudo_energy_pair(void);
	int optimistic_pseudo_energy_stack(vector<int> stack);
	int optimistic_pseudo_energy_structure(vector<int> stack_in_str, vector< vector<int> > stacks);

};
