#include <iostream>
#include <string>
#include <vector>
#include "energy_parameters.h"
#include "shape_reactivity.h"

#define LARGENUM 999999

using namespace std;

class single_fold_stack	{
	public:
	string sequence;
	string structure;
	
	int fold_energy;
	vector< vector<int> > stacks;
	vector< vector<int> > stack_hash;
	vector<double> reactivity;
	
	vector<int> num_enclosing;
	vector< vector<int> > enclosing;
	vector<int> num_internal;
	vector< vector<int> > internal;
	vector<int> num_Fset;
	vector< vector<int> > Fset;
	vector<int> num_FPset;
	vector< vector<int> > FPset;
	
	vector<int> energy_matrix;
	vector< vector<int> > energy_matrix_multi;
	vector<int> traceback_matrix_type;
	vector<int> traceback_matrix;
	vector< vector<int> > traceback_matrix_multi;
	vector< vector<int> > traceback_matrix_multi_type;
	
	single_fold_stack(string input_sequence, string input_SHAPE_file, int min_stack_length, int min_stack_hydro_bonds);
	single_fold_stack(string input_sequence);
	~single_fold_stack(void);
	
	/* folding structures enclosed by stack i */
	void fold();
	void fold_SHAPE();
	void fold_SHAPE_constrained(string constrained_str, int frequency);
	
	int num_hydro_bonds(char a, char b);
	int predict_stacks(int min_length, int min_hydro_bonds);
	void build_stacks(void);
	void sort_stacks(void);
	void traceback_stack(int i);
	void traceback_multi(int i, int m);
	
	void append_stack(vector<int> stack, string &structure);
	void clear_structure(void);
	
	int evaluate_energy_stack(vector<int> stack_in_str);
};
